#motor control
import Adafruit_BBIO.GPIO as GPIO
import Adafruit_BBIO.PWM as PWM
import time

class motorcontrol(object):
    #globals for testing
    x=0
    y=0
    armfreq = 3000 #Hz
    duty = 50 #%
    
    # intitialize
    def __init__(self):
        # Stepper Motor Control 1 & 2 (Camera Tilt & Pan)
        # set up pins to run stepper motor pulse & direction
        GPIO.setup("P8_44", GPIO.OUT) #pin P8-44 pinTiltM1,pinPanM1
        GPIO.setup("P8_10", GPIO.OUT) #pin P8-10 pinTiltM2,pinPanM2
        GPIO.setup("P8_11", GPIO.OUT) #pin P8-11 LefttrackM1,RighttrackM1
        GPIO.setup("P8_13", GPIO.OUT) #pin P8-13 LefttrackM2,RighttrackM2
        GPIO.setup("P8_35", GPIO.OUT) #pin P8-35 arm1M1,arm2M1, & noseM1
        GPIO.setup("P8_37", GPIO.OUT) #pin P8-37 arm1M2,arm2M2, & noseM2
        # M1=0, M2=0 full step
        # M1=1, M2=0 1/4 step
        # M1=0, M2=1 1/16 step
        # M1=1, M2=1 1/32 step
        GPIO.setup("P9_11", GPIO.OUT) #pin P9-11 pinTPreset
        GPIO.setup("P8_39", GPIO.OUT) #pin P8-39 pinTPreset
        GPIO.setup("P8_28", GPIO.OUT) #pin P8-28 pinTiltdir
        GPIO.setup("P8_30", GPIO.OUT) #pin P8-30 pinPandir 
        GPIO.setup("P8_27", GPIO.OUT) #pin P8-27 RighttrackReset
        GPIO.setup("P8_29", GPIO.OUT) #pin P8-29 LefttrackReset
        GPIO.setup("P8_31", GPIO.OUT) #pin P8-31 Lefttrackdir
        GPIO.setup("P8_33", GPIO.OUT) #pin P9-15 Righhttrackdir 
        GPIO.setup("P9_13", GPIO.OUT) #pin P9-13 arm1Reset
        GPIO.setup("P9_15", GPIO.OUT) #pin P9-15 arm2Reset
        GPIO.setup("P9_17", GPIO.OUT) #pin P8-31 noseReset
        GPIO.setup("P9_23", GPIO.OUT) #pin P9-23 arm1dir
        GPIO.setup("P9_25", GPIO.OUT) #pin P9-25 arm2dir 
        GPIO.setup("P9_27", GPIO.OUT) #pin P9-27 nosedir 

        # variable to set frequency and pulse width for testing
        #freq = 500 #Hz
        #duty = 50 #%
        #PWM.start("P8_34",duty,freq,0)  #PWM1A pin P8-36
        #PWM.start("P9_31",duty,freq,0)  #PWM1A pin P8-36
        # need to set pin to pwm # config-pin -a p9.31 pwm 
        #PWM.start("P8_45",duty,freq,0)  #PWM2A pin P8-45
        # need to set pin to pwm # config-pin -a p8.45 pwm 
        print "initilized"
    # destructor
    def __del__(self):
        PWM.stop("P8_34")
        GPIO.output("P8_39",0) #pinTPreset pin P9-11
        GPIO.output("P8_44",0) #pinTiltM1, PanM1 pin P8-44
        GPIO.output("P8_10",0) #pinTiltM2 PanM2 P8-10
      
        PWM.stop("P8_36")
        GPIO.output("P9_11",1) #pinTPreset pin P8-39
        GPIO.output("P8_44",1) #pinTiltM1, PanM1 pin P8-44
        GPIO.output("P8_10",1) #pinTiltM2 PanM2 P8-10
     
        PWM.stop("P8_46")
        GPIO.output("P9_15",0) #pin P9-15 arm2Reset
        GPIO.output("P8_35",0) #pin P8-35 arm1M1,arm2M1, & noseM1
        GPIO.output("P8_37",0) #pin P8-37 arm1M2,arm2M2, & noseM2
        PWM.cleanup()

        print 'end'

    def cutpower(self):
        PWM.stop("P8_34")
        GPIO.output("P8_39",0) #pinTPreset pin P9-11
        GPIO.output("P8_44",0) #pinTiltM1, PanM1 pin P8-44
        GPIO.output("P8_10",0) #pinTiltM2 PanM2 P8-10
        
        PWM.stop("P8_36")
        GPIO.output("P9_11",0) #pinTPreset pin P8-39
        GPIO.output("P8_44",0) #pinTiltM1, PanM1 pin P8-44
        GPIO.output("P8_10",0) #pinTiltM2 PanM2 P8-10
        
        PWM.stop("P8_46")
        GPIO.output("P9_15",0) #pin P9-15 arm2Reset
        GPIO.output("P8_35",0) #pin P8-35 arm1M1,arm2M1, & noseM1
        GPIO.output("P8_37",0) #pin P8-37 arm1M2,arm2M2, & noseM2
        PWM.cleanup()


    def panmotor(self,direction,active):
        freq = 500 #Hz
        duty = 50 #%
        PWM.start("P8_36",duty,freq,0)  #PWM1A pin P8-36
        PWM.start("P8_34",0,freq,0)  #PWM1A pin P8-36
        # need to set pin to pwm config-pin -a p8.36 pwm  
        if active==1:
            GPIO.output("P8_39",1) # pinTPreset pin P9-11
            GPIO.output("P8_44",1) #pinTiltM1, PanM1 pin P8-44
            GPIO.output("P8_10",1) #pinTiltM2 PanM2 P8-10
            GPIO.output("P8_30",direction) #pinPandir pin P8-30
        if active==0:
            PWM.stop("P8_34")
            PWM.stop("P8_36")
            GPIO.output("P8_39",1) #pinTPreset pin P9-11
            GPIO.output("P8_44",1) #pinTiltM1, PanM1 pin P8-44
            GPIO.output("P8_10",1) #pinTiltM2 PanM2 P8-10
            PWM.cleanup()

    def tiltmotor(self,direction,active):
        freq = 500 #Hz
        duty = 50 #%
        PWM.start("P8_34",duty,freq,0)  #PWM1A pin P8-36
        PWM.start("P8_36",0,freq,0)  #PWM1A pin P8-36
        # need to set pin to pwm config-pin -a p8.36 pwm  
        if active==1:
            GPIO.output("P9_11",1) # pinTPreset pin P8-39
            GPIO.output("P8_44",1) #pinTiltM1, PanM1 pin P8-44
            GPIO.output("P8_10",1) #pinTiltM2 PanM2 P8-10
            GPIO.output("P8_28",direction) #pinTiltdir pin P8-28
        if active==0:
            PWM.stop("P8_36")
            PWM.stop("P8_34")
            GPIO.output("P9_11",1) #pinTPreset pin P8-39
            GPIO.output("P8_44",1) #pinTiltM1, PanM1 pin P8-44
            GPIO.output("P8_10",1) #pinTiltM2 PanM2 P8-10
            PWM.cleanup()

    def left(self,direction,active,frequency):
        freq = float(frequency) #Hz 20000 #Hz
        duty = 50 #%
        PWM.start("P9_31",duty,freq,0)  #PWM1A pin P8-36
        # need to set pin to pwm # config-pin -a p9.31 pwm
        if active==1:
            GPIO.output("P8_27",1) #pin P8-27 LefttrackReset,RighttrackReset
            GPIO.output("P8_29",1) #pin P8-29 LefttrackReset,RighttrackReset
            GPIO.output("P8_11",1) #pin P8-11 LefttrackM1,RighttrackM1
            GPIO.output("P8_13",1) #pin P8-13 LefttrackM2,RighttrackM2
            GPIO.output("P8_31",(1-direction)) #pin P8-31 Lefttrackdir
            GPIO.output("P8_33",(direction)) #pin P8-33 Righhttrackdir 
        if active==0:
            PWM.stop("P9_31")
            GPIO.output("P8_27",0) #pin P8-27 LefttrackReset,RighttrackReset
            GPIO.output("P8_29",0) #pin P8-29 LefttrackReset,RighttrackReset
            GPIO.output("P8_11",0) #pin P8-11 LefttrackM1,RighttrackM1
            GPIO.output("P8_13",0) #pin P8-13 LefttrackM2,RighttrackM2
            GPIO.output("P8_31",0) #pin P8-31 Lefttrackdir
            GPIO.output("P8_33",0) #pin P8-33 Righhttrackdir  
            PWM.cleanup()
    def right(self,direction,active,frequency):
        freq = float(frequency) #Hz
        duty = 50 #%
        PWM.start("P9_31",duty,freq,0)  #PWM1A pin P8-36
        # need to set pin to pwm # config-pin -a p9.31 pwm
        if active==1:
            GPIO.output("P8_27",1) #pin P8-27 LefttrackReset,RighttrackReset
            GPIO.output("P8_29",1) #pin P8-29 LefttrackReset,RighttrackReset
            GPIO.output("P8_11",1) #pin P8-11 LefttrackM1,RighttrackM1
            GPIO.output("P8_13",1) #pin P8-13 LefttrackM2,RighttrackM2
            GPIO.output("P8_31",(direction)) #pin P8-31 Lefttrackdir
            GPIO.output("P8_33",(1-direction)) #pin P8-33 Righhttrackdir 
        if active==0:
            PWM.stop("P9_31")
            GPIO.output("P8_27",0) #pin P8-27 LefttrackReset,RighttrackReset
            GPIO.output("P8_29",0) #pin P8-29 LefttrackReset,RighttrackReset
            GPIO.output("P8_11",0) #pin P8-11 LefttrackM1,RighttrackM1
            GPIO.output("P8_13",0) #pin P8-13 LefttrackM2,RighttrackM2
            GPIO.output("P8_31",0) #pin P8-31 Lefttrackdir
            GPIO.output("P8_33",0) #pin P8-33 Righhttrackdir  
            PWM.cleanup()         
     
    def forward(self,direction,active,frequency):
        freq = float(frequency) #Hz
        duty = 50 #%
        PWM.start("P9_31",duty,freq,0)  #PWM1A pin P8-36
        # need to set pin to pwm # config-pin -a p9.31 pwm
        if active==1:
            GPIO.output("P8_27",1) #pin P8-27 LefttrackReset,RighttrackReset
            GPIO.output("P8_29",1) #pin P8-29 LefttrackReset,RighttrackReset
            GPIO.output("P8_11",0) #pin P8-11 LefttrackM1,RighttrackM1
            GPIO.output("P8_13",1) #pin P8-13 LefttrackM2,RighttrackM2
            GPIO.output("P8_31",(direction)) #pin P8-31 Lefttrackdir
            GPIO.output("P8_33",(direction)) #pin P8-33 Righhttrackdir 
        if active==0:
            PWM.stop("P9_31")
            GPIO.output("P8_27",0) #pin P8-27 LefttrackReset,RighttrackReset
            GPIO.output("P8_29",0) #pin P8-29 LefttrackReset,RighttrackReset
            GPIO.output("P8_11",0) #pin P8-11 LefttrackM1,RighttrackM1
            GPIO.output("P8_13",0) #pin P8-13 LefttrackM2,RighttrackM2
            GPIO.output("P8_31",0) #pin P8-31 Lefttrackdir
            GPIO.output("P8_33",0) #pin P8-33 Righhttrackdir  
            PWM.cleanup()         
            
    def arm1(self,direction,active):
        freq = 5000 #Hz
        duty = 50 #%        
        PWM.start("P8_45",duty,freq,0)  #PWM2A pin P8-45
        PWM.start("P8_46",0,freq,0)  #PWM1A pin P8-36
        if active==1:
            GPIO.output("P9_13",1) #pin P8-16 arm1Reset
            GPIO.output("P8_35",1) #pin P8-35 arm1M1,arm2M1, & noseM1
            GPIO.output("P8_37",1) #pin P8-37 arm1M2,arm2M2, & noseM2
            GPIO.output("P9_23",direction) #pin P9-23 arm1dir
        if active==0:
            PWM.stop("P8_45")
            PWM.stop("P8_46")
            GPIO.output("P9_13",0) #pin P8-16 arm1Reset
            GPIO.output("P8_35",0) #pin P8-35 arm1M1,arm2M1, & noseM1
            GPIO.output("P8_37",0) #pin P8-37 arm1M2,arm2M2, & noseM2
            GPIO.output("P9_23",0) #pin P9-23 arm1dir
            PWM.cleanup() 
    
    def arm2(self,direction,active):
        freq = 5000 #Hz
        duty = 50 #%        
        PWM.start("P8_46",duty,freq,0)  #PWM2A pin P8-46 aet 45 and 46 have to have same freq
        PWM.start("P8_45",0,freq,0)  #PWM1A pin P8-36
        if active==1:
            GPIO.output("P9_15",1) #pin P9-15 arm2Reset
            GPIO.output("P8_35",1) #pin P8-35 arm1M1,arm2M1, & noseM1
            GPIO.output("P8_37",1) #pin P8-37 arm1M2,arm2M2, & noseM2
            GPIO.output("P9_25",direction) #pin P9-25 arm2dir
        if active==0:
            PWM.stop("P8_46")
            PWM.stop("P8_45")
            GPIO.output("P9_15",1) #pin P9-15 arm2Reset
            GPIO.output("P8_35",1) #pin P8-35 arm1M1,arm2M1, & noseM1
            GPIO.output("P8_37",1) #pin P8-37 arm1M2,arm2M2, & noseM2
            GPIO.output("P9_25",0) #pin P9-25 arm2dir
            PWM.cleanup() 
    
    def arm3(self,direction,active):
        freq = 5000 #Hz
        duty = 50 #%        
        PWM.start("P8_45",duty,freq,0)  #PWM2A pin P8-45
        PWM.start("P8_46",0,freq,0)  #PWM1A pin P8-36
        if active==1:
            GPIO.output("P9_17",1) #pin P9-17 noseReset
            GPIO.output("P8_35",1) #pin P8-35 arm1M1,arm2M1, & noseM1
            GPIO.output("P8_37",1) #pin P8-37 arm1M2,arm2M2, & noseM2
            GPIO.output("P9_27",direction)  #pin P9-27 nosedir
        if active==0:
            PWM.stop("P8_45")
            PWM.stop("P8_46")
            GPIO.output("P9_17",0) #pin P9-17 noseReset
            GPIO.output("P8_35",0) #pin P8-35 arm1M1,arm2M1, & noseM1
            GPIO.output("P8_37",0) #pin P8-37 arm1M2,arm2M2, & noseM2
            GPIO.output("P9_27",0)  #pin P9-27 nosedir
            PWM.cleanup() 
            
   